#include "client.hpp"
#include "definitions.hpp"
#include "server.hpp"
#include <cstdio>
#include <strings.h>
#include <unistd.h>

Client::Client() : sock(), serverAddr() {
  sock = socket(AF_INET, SOCK_STREAM, 0);
  serverAddr.sin_family = AF_INET;
  serverAddr.sin_port = htons(DEFAULT_PORT);
  inet_aton(DEFAULT_IP, &serverAddr.sin_addr);
  int rc = connect(sock, (struct sockaddr *)&serverAddr, sizeof(serverAddr));
  if (rc < 0) {
    perror("connect() failed");
    return;
  }
}

Client::Client(const std::string &addr, const int &port) {
  sock = socket(AF_INET, SOCK_STREAM, 0);
  serverAddr.sin_family = AF_INET;
  serverAddr.sin_port = htons(port);
  inet_aton(addr.c_str(), &serverAddr.sin_addr);
  int rc = connect(sock, (struct sockaddr *)&serverAddr, sizeof(serverAddr));
  if (rc < 0) {
    perror("connect() failed");
    return;
  }
}

void Client::disconnect() { close(sock); }

uint16_t Client::sendMessage(const char *msg) {
  return send(sock, msg, strlen(msg) + 1, 0);
}

void Client::receiveMessage() {
  int nbytesrecv = recv(sock, inputBuffer, INPUT_BUFFER_SIZE, 0);

  if (nbytesrecv <= 0) {
    if (nbytesrecv == 0) {
      disconnect();
      return;
    } else {
      perror("recv() failed");
    }
    close(sock);
    return;
  }
  receiveCallback(sock, inputBuffer);
  bzero(&inputBuffer, INPUT_BUFFER_SIZE);
}
